OGRE: Ogre::RenderTarget Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::RenderTarget Class Reference

A 'canvas' which can receive the results of a rendering operation. More...

`#include <OgreRenderTarget.h>`

Inheritance diagram for Ogre::RenderTarget:

[legend]
List of all members.

## Public Types

enum | StatFlags { SF_NONE = 0, SF_FPS = 1, SF_AVG_FPS = 2, SF_BEST_FPS = 4, SF_WORST_FPS = 8, SF_TRIANGLE_COUNT = 16, SF_ALL = 0xFFFF }

## Public Member Functions

| RenderTarget ()
virtual | ~RenderTarget ()
virtual const String & | getName (void) const
| Retrieve target's name.
virtual void | getMetrics (unsigned int &width, unsigned int &height, unsigned int &colourDepth)
| Retrieve information about the render target.
virtual unsigned int | getWidth (void) const
virtual unsigned int | getHeight (void) const
virtual unsigned int | getColourDepth (void) const
virtual void | update (void)
| Tells the target to update it's contents.
virtual Viewport * | addViewport (Camera *cam, int ZOrder=0, float left=0.0f, float top=0.0f, float width=1.0f, float height=1.0f)
| Adds a viewport to the rendering target.
virtual unsigned short | getNumViewports (void) const
| Returns the number of viewports attached to this target.
virtual Viewport * | getViewport (unsigned short index)
| Retrieves a pointer to the viewport with the given index.
virtual void | removeViewport (int ZOrder)
| Removes a viewport at a given ZOrder.
virtual void | removeAllViewports (void)
| Removes all viewports on this target.
virtual void | getStatistics (float &lastFPS, float &avgFPS, float &bestFPS, float &worstFPS) const
| Retieves details of current rendering performance.
virtual const FrameStats & | getStatistics (void) const
virtual float | getLastFPS () const
| Individual stats access - gets the number of frames per second (FPS) based on the last frame rendered.
virtual float | getAverageFPS () const
| Individual stats access - gets the average frames per second (FPS) since call to Root::startRendering.
virtual float | getBestFPS () const
| Individual stats access - gets the best frames per second (FPS) since call to Root::startRendering.
virtual float | getWorstFPS () const
| Individual stats access - gets the worst frames per second (FPS) since call to Root::startRendering.
virtual float | getBestFrameTime () const
| Individual stats access - gets the best frame time.
virtual float | getWorstFrameTime () const
| Individual stats access - gets the worst frame time.
virtual void | resetStatistics (void)
| Resets saved frame-rate statistices.
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute.
virtual void | addListener (RenderTargetListener *listener)
| Add a listener to this RenderTarget which will be called back before & after rendering.
virtual void | removeListener (RenderTargetListener *listener)
| Removes a RenderTargetListener previously registered using addListener.
virtual void | removeAllListeners (void)
| Removes all listeners from this instance.
virtual void | setPriority (uchar priority)
| Sets the priority of this render target in relation to the others.
virtual uchar | getPriority () const
| Gets the priority of a render target.
virtual bool | isActive () const
| Used to retrieve or set the active state of the render target.
virtual void | setActive (bool state)
| Used to set the active state of the render target.
virtual void | setAutoUpdated (bool autoupdate)
| Sets whether this target should be automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
virtual bool | isAutoUpdated (void) const
| Gets whether this target is automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
virtual void | writeContentsToFile (const String &filename)=0
| Writes the current contents of the render target to the named file.
virtual String | writeContentsToTimestampedFile (const String &filenamePrefix, const String &filenameSuffix)
| Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.
virtual bool | requiresTextureFlipping () const =0
virtual size_t | getTriangleCount (void) const
| Gets the number of triangles rendered in the last update() call.
virtual size_t | getBatchCount (void) const
| Gets the number of batches rendered in the last update() call.
virtual void | _notifyCameraRemoved (const Camera *cam)
| Utility method to notify a render target that a camera has been removed, incase it was referring to it as a viewer.
virtual bool | isPrimary (void) const
| Indicates whether this target is the primary window.
virtual Impl * | _getImpl ()
| Get rendersystem specific interface for this RenderTarget.

## Protected Types

typedef std::map< int, Viewport *, std::less< int > > | ViewportList
typedef std::vector< RenderTargetListener * > | RenderTargetListenerList

## Protected Member Functions

void | updateStats (void)
virtual void | firePreUpdate (void)
| internal method for firing events
virtual void | firePostUpdate (void)
| internal method for firing events
virtual void | fireViewportPreUpdate (Viewport *vp)
| internal method for firing events
virtual void | fireViewportPostUpdate (Viewport *vp)
| internal method for firing events
virtual void | fireViewportAdded (Viewport *vp)
| internal method for firing events
virtual void | fireViewportRemoved (Viewport *vp)
| internal method for firing events

## Protected Attributes

String | mName
| The name of this target.
uchar | mPriority
| The priority of the render target.
unsigned int | mWidth
unsigned int | mHeight
unsigned int | mColourDepth
bool | mIsDepthBuffered
FrameStats | mStats
Timer * | mTimer
unsigned long | mLastSecond
unsigned long | mLastTime
size_t | mFrameCount
bool | mActive
bool | mAutoUpdate
ViewportList | mViewportList
| List of viewports, map on Z-order.
RenderTargetListenerList | mListeners

## Classes

struct | FrameStats
class | Impl
| RenderSystem specific interface for a RenderTarget; this should be subclassed by RenderSystems. More...

## Detailed Description

A 'canvas' which can receive the results of a rendering operation.

Remarks:
  This abstract class defines a common root to all targets of rendering operations. A render target could be a window on a screen, or another offscreen surface like a texture or bump map etc.

Author:
  Steven Streeting

Version:
  1.0

Definition at line 59 of file OgreRenderTarget.h.

## Member Typedef Documentation

typedef std::vector<RenderTargetListener*> Ogre::RenderTarget::RenderTargetListenerList`[protected]`

| Definition at line 339 of file OgreRenderTarget.h.

typedef std::map<int, Viewport*, std::less<int> > Ogre::RenderTarget::ViewportList`[protected]`

| Definition at line 335 of file OgreRenderTarget.h.

## Member Enumeration Documentation

enum Ogre::RenderTarget::StatFlags

Enumeration values:

  SF_NONE |
  SF_FPS |
  SF_AVG_FPS |
  SF_BEST_FPS |
  SF_WORST_FPS |
  SF_TRIANGLE_COUNT |
  SF_ALL |

Definition at line 62 of file OgreRenderTarget.h.

## Constructor & Destructor Documentation

Ogre::RenderTarget::RenderTarget | ( |  | ) |

virtual Ogre::RenderTarget::~RenderTarget | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual Impl* Ogre::RenderTarget::_getImpl | ( |  | ) | `[virtual]`

| Get rendersystem specific interface for this RenderTarget. This is used by the RenderSystem to (un)bind this target, and to get specific information like surfaces and framebuffer objects.

virtual void Ogre::RenderTarget::_notifyCameraRemoved | ( | const Camera * | cam | ) | `[virtual]`

| Utility method to notify a render target that a camera has been removed, incase it was referring to it as a viewer.

virtual void Ogre::RenderTarget::addListener | ( | RenderTargetListener * | listener | ) | `[virtual]`

Add a listener to this RenderTarget which will be called back before & after rendering.

Remarks:
  If you want notifications before and after a target is updated by the system, use this method to register your own custom RenderTargetListener class. This is useful for potentially adding your own manual rendering commands before and after the 'normal' system rendering.

NB this should not be used for frame-based scene updates, use Root::addFrameListener for that.

virtual Viewport* Ogre::RenderTarget::addViewport | ( | Camera * | cam,
|  | int | ZOrder = `0`,
|  | float | left = `0.0f`,
|  | float | top = `0.0f`,
|  | float | width = `1.0f`,
|  | float | height = `1.0f`
| ) | `[virtual]`

Adds a viewport to the rendering target.

Remarks:
  A viewport is the rectangle into which redering output is sent. This method adds a viewport to the render target, rendering from the supplied camera. The rest of the parameters are only required if you wish to add more than one viewport to a single rendering target. Note that size information passed to this method is passed as a parametric, i.e. it is relative rather than absolute. This is to allow viewports to automatically resize along with the target.

Parameters:

  | cam | The camera from which the viewport contents will be rendered (mandatory)
  | ZOrder | The relative order of the viewport with others on the target (allows overlapping viewports i.e. picture-in-picture). Higher ZOrders are on top of lower ones. The actual number is irrelevant, only the relative ZOrder matters (you can leave gaps in the numbering)
  | left | The relative position of the left of the viewport on the target, as a value between 0 and 1.
  | top | The relative position of the top of the viewport on the target, as a value between 0 and 1.
  | width | The relative width of the viewport on the target, as a value between 0 and 1.
  | height | The relative height of the viewport on the target, as a value between 0 and 1.

virtual void Ogre::RenderTarget::firePostUpdate | ( | void |  | ) | `[protected, virtual]`

| internal method for firing events

virtual void Ogre::RenderTarget::firePreUpdate | ( | void |  | ) | `[protected, virtual]`

| internal method for firing events

virtual void Ogre::RenderTarget::fireViewportAdded | ( | Viewport * | vp | ) | `[protected, virtual]`

| internal method for firing events

virtual void Ogre::RenderTarget::fireViewportPostUpdate | ( | Viewport * | vp | ) | `[protected, virtual]`

| internal method for firing events

virtual void Ogre::RenderTarget::fireViewportPreUpdate | ( | Viewport * | vp | ) | `[protected, virtual]`

| internal method for firing events

virtual void Ogre::RenderTarget::fireViewportRemoved | ( | Viewport * | vp | ) | `[protected, virtual]`

| internal method for firing events

virtual float Ogre::RenderTarget::getAverageFPS | ( |  | ) | const`[virtual]`

| Individual stats access - gets the average frames per second (FPS) since call to Root::startRendering.

virtual size_t Ogre::RenderTarget::getBatchCount | ( | void |  | ) | const`[virtual]`

| Gets the number of batches rendered in the last update() call.

virtual float Ogre::RenderTarget::getBestFPS | ( |  | ) | const`[virtual]`

| Individual stats access - gets the best frames per second (FPS) since call to Root::startRendering.

virtual float Ogre::RenderTarget::getBestFrameTime | ( |  | ) | const`[virtual]`

| Individual stats access - gets the best frame time.

virtual unsigned int Ogre::RenderTarget::getColourDepth | ( | void |  | ) | const`[virtual]`

virtual void Ogre::RenderTarget::getCustomAttribute | ( | const String & | name,
|  | void * | pData
| ) | `[virtual]`

Gets a custom (maybe platform-specific) attribute.

Remarks:
  This is a nasty way of satisfying any API's need to see platform-specific details. It horrid, but D3D needs this kind of info. At least it's abstracted.

Parameters:

  | name | The name of the attribute.
  | pData | Pointer to memory of the right kind of structure to receive the info.

virtual unsigned int Ogre::RenderTarget::getHeight | ( | void |  | ) | const`[virtual]`

virtual float Ogre::RenderTarget::getLastFPS | ( |  | ) | const`[virtual]`

| Individual stats access - gets the number of frames per second (FPS) based on the last frame rendered.

virtual void Ogre::RenderTarget::getMetrics | ( | unsigned int & | width,
|  | unsigned int & | height,
|  | unsigned int & | colourDepth
| ) | `[virtual]`

| Retrieve information about the render target.

virtual const String& Ogre::RenderTarget::getName | ( | void |  | ) | const`[virtual]`

| Retrieve target's name.

virtual unsigned short Ogre::RenderTarget::getNumViewports | ( | void |  | ) | const`[virtual]`

| Returns the number of viewports attached to this target.

virtual uchar Ogre::RenderTarget::getPriority | ( |  | ) | const`[virtual]`

| Gets the priority of a render target. Definition at line 238 of file OgreRenderTarget.h.

virtual const FrameStats& Ogre::RenderTarget::getStatistics | ( | void |  | ) | const`[virtual]`

virtual void Ogre::RenderTarget::getStatistics | ( | float & | lastFPS,
|  | float & | avgFPS,
|  | float & | bestFPS,
|  | float & | worstFPS
| ) | const`[virtual]`

Retieves details of current rendering performance.

Remarks:
  If the user application wishes to do it's own performance display, or use performance for some other means, this method allows it to retrieve the statistics.

Parameters:

  | lastFPS | Pointer to a float to receive the number of frames per second (FPS) based on the last frame rendered.
  | avgFPS | Pointer to a float to receive the FPS rating based on an average of all the frames rendered since rendering began (the call to Root::startRendering).
  | bestFPS | Pointer to a float to receive the best FPS rating that has been achieved since rendering began.
  | worstFPS | Pointer to a float to receive the worst FPS rating seen so far.

virtual size_t Ogre::RenderTarget::getTriangleCount | ( | void |  | ) | const`[virtual]`

| Gets the number of triangles rendered in the last update() call.

virtual Viewport* Ogre::RenderTarget::getViewport | ( | unsigned short | index | ) | `[virtual]`

| Retrieves a pointer to the viewport with the given index.

virtual unsigned int Ogre::RenderTarget::getWidth | ( | void |  | ) | const`[virtual]`

virtual float Ogre::RenderTarget::getWorstFPS | ( |  | ) | const`[virtual]`

| Individual stats access - gets the worst frames per second (FPS) since call to Root::startRendering.

virtual float Ogre::RenderTarget::getWorstFrameTime | ( |  | ) | const`[virtual]`

| Individual stats access - gets the worst frame time.

virtual bool Ogre::RenderTarget::isActive | ( |  | ) | const`[virtual]`

| Used to retrieve or set the active state of the render target. Reimplemented in Ogre::RenderWindow.

virtual bool Ogre::RenderTarget::isAutoUpdated | ( | void |  | ) | const`[virtual]`

| Gets whether this target is automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.

virtual bool Ogre::RenderTarget::isPrimary | ( | void |  | ) | const`[virtual]`

Indicates whether this target is the primary window.

The primary window is special in that it is destroyed when ogre is shut down, and cannot be destroyed directly. This is the case because it holds the context for vertex, index buffers and textures.

Reimplemented in Ogre::RenderWindow.

virtual void Ogre::RenderTarget::removeAllListeners | ( | void |  | ) | `[virtual]`

| Removes all listeners from this instance.

virtual void Ogre::RenderTarget::removeAllViewports | ( | void |  | ) | `[virtual]`

| Removes all viewports on this target.

virtual void Ogre::RenderTarget::removeListener | ( | RenderTargetListener * | listener | ) | `[virtual]`

| Removes a RenderTargetListener previously registered using addListener.

virtual void Ogre::RenderTarget::removeViewport | ( | int | ZOrder | ) | `[virtual]`

| Removes a viewport at a given ZOrder.

virtual bool Ogre::RenderTarget::requiresTextureFlipping | ( |  | ) | const`[pure virtual]`

virtual void Ogre::RenderTarget::resetStatistics | ( | void |  | ) | `[virtual]`

| Resets saved frame-rate statistices.

virtual void Ogre::RenderTarget::setActive | ( | bool | state | ) | `[virtual]`

| Used to set the active state of the render target.

virtual void Ogre::RenderTarget::setAutoUpdated | ( | bool | autoupdate | ) | `[virtual]`

Sets whether this target should be automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.

Remarks:
  By default, if you use Ogre's own rendering loop (Root::startRendering) or call Root::_updateAllRenderTargets, all render targets are updated automatically. This method allows you to control that behaviour, if for example you have a render target which you only want to update periodically.

Parameters:

  | autoupdate | If true, the render target is updated during the automatic render loop or when Root::_updateAllRenderTargets is called. If false, the target is only updated when its update() method is called explicitly.

virtual void Ogre::RenderTarget::setPriority | ( | uchar | priority | ) | `[virtual]`

Sets the priority of this render target in relation to the others.

Remarks:
  This can be used in order to schedule render target updates. Lower priorities will be rendered first. Note that the priority must be set at the time the render target is attached to the render system, changes afterwards will not affect the ordering.

Definition at line 236 of file OgreRenderTarget.h.

virtual void Ogre::RenderTarget::update | ( | void |  | ) | `[virtual]`

Tells the target to update it's contents.

Remarks:
  If OGRE is not running in an automatic rendering loop (started using Root::startRendering), the user of the library is responsible for asking each render target to refresh. This is the method used to do this. It automatically re-renders the contents of the target using whatever cameras have been pointed at it (using Camera::setRenderTarget).

  This allows OGRE to be used in multi-windowed utilities and for contents to be refreshed only when required, rather than constantly as with the automatic rendering loop.

Reimplemented in Ogre::RenderWindow.

void Ogre::RenderTarget::updateStats | ( | void |  | ) | `[protected]`

virtual void Ogre::RenderTarget::writeContentsToFile | ( | const String & | filename | ) | `[pure virtual]`

| Writes the current contents of the render target to the named file. Implemented in Ogre::RenderTexture, and Ogre::MultiRenderTarget.

virtual String Ogre::RenderTarget::writeContentsToTimestampedFile | ( | const String & | filenamePrefix,
|  | const String & | filenameSuffix
| ) | `[virtual]`

Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.

Returns:
  the name of the file used.

## Member Data Documentation

bool Ogre::RenderTarget::mActive`[protected]`

| Definition at line 330 of file OgreRenderTarget.h.

bool Ogre::RenderTarget::mAutoUpdate`[protected]`

| Definition at line 331 of file OgreRenderTarget.h.

unsigned int Ogre::RenderTarget::mColourDepth`[protected]`

| Definition at line 319 of file OgreRenderTarget.h.

size_t Ogre::RenderTarget::mFrameCount`[protected]`

| Definition at line 328 of file OgreRenderTarget.h.

unsigned int Ogre::RenderTarget::mHeight`[protected]`

| Definition at line 318 of file OgreRenderTarget.h.

bool Ogre::RenderTarget::mIsDepthBuffered`[protected]`

| Definition at line 320 of file OgreRenderTarget.h.

unsigned long Ogre::RenderTarget::mLastSecond`[protected]`

| Definition at line 326 of file OgreRenderTarget.h.

unsigned long Ogre::RenderTarget::mLastTime`[protected]`

| Definition at line 327 of file OgreRenderTarget.h.

RenderTargetListenerList Ogre::RenderTarget::mListeners`[protected]`

| Definition at line 340 of file OgreRenderTarget.h.

String Ogre::RenderTarget::mName`[protected]`

| The name of this target. Definition at line 313 of file OgreRenderTarget.h.

uchar Ogre::RenderTarget::mPriority`[protected]`

| The priority of the render target. Definition at line 315 of file OgreRenderTarget.h.

FrameStats Ogre::RenderTarget::mStats`[protected]`

| Definition at line 323 of file OgreRenderTarget.h.

Timer* Ogre::RenderTarget::mTimer`[protected]`

| Definition at line 325 of file OgreRenderTarget.h.

ViewportList Ogre::RenderTarget::mViewportList`[protected]`

| List of viewports, map on Z-order. Definition at line 337 of file OgreRenderTarget.h.

unsigned int Ogre::RenderTarget::mWidth`[protected]`

| Definition at line 317 of file OgreRenderTarget.h.

The documentation for this class was generated from the following file:

- OgreRenderTarget.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:07 2008